#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    # N.B. 1.3.0 and later requires xcb.
    tar xjf xdpyinfo-1.2.0.tar.bz2
    cd xdpyinfo-1.2.0
    ./configure --prefix=/usr --sysconfdir=/etc/X11 --localstatedir=/var \
	    --datadir=/usr/lib
    # FIXME: Xxf86misc is deprecated, no longer available in Squeeze(?)
    make xdpyinfo_LDADD="-lX11 -lXext -Wl,-Bstatic -lXp -lXtst -lXxf86vm \
	    -lXxf86dga -lXxf86misc -lXcomposite -lXi -ldmx -lXrender \
	    -lXinerama -Wl,-Bdynamic"
    strip -R .note -R .comment xdpyinfo
    mkdir -p ../xdpyinfo/bin
    cp xdpyinfo ../xdpyinfo/bin/
    cd ..
    rm -rf xdpyinfo-1.2.0
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
